'Internet radio - project: http://mightyohm.com/blog/2008/10/building-a-wifi-radio-part-1-introduction/
'ported from Asus WL-520GU to Linksys WRT54G-TM
'Pawel Koch / 2010.12.19

'Environment: Bascom 2.0.2.0 / m8def.dat
'ucontroller: ATmega8, internal clock @8MHz
'USART baudrate: 19200

$lib "I2C_TWI.LBX"                                          'necessary for proper I2C communication

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db7 = Portb.2 , Db6 = Portb.3 , Db5 = Portb.1 , Db4 = Portb.4 , E = Portb.5 , Rs = Portb.0
Cursor Off Noblink
$regfile = "m8def.dat"                                      'reg to inform compilator about to which uC should surce be compiled

$crystal = 8000000
$baud = 19200                                               'baudrate setup
Config Com1 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0

Config Serialout = Buffered , Size = 96                     'USART - buffer out
Config Serialin = Buffered , Size = 180                     'USART - buffer in

Config Rc5 = Pind.2                                         'RC5 IR detector will be connected to PinD.2
Config Sda = Portc.4                                        'I2C SDA will be on PORTC.4
Config Scl = Portc.5                                        'I2C SCL will be on PORTC.5
Config Debounce = 50                                        '50us to avold contacts flipping for buttons
Enable Interrupts                                           'necessary for GetRC5 procedure to be working
Dim A As Byte
Dim B As Byte
Dim C As String * 180
Dim Syg1 As Byte
Dim Syg2 As Byte
Dim Name_len As Byte
Dim Title_len As Byte
Dim Temp_str As String * 4
Dim Loop_counter As Byte
Dim Play As String * 48
Dim Title As String * 48
Dim Message As String * 16
Dim I As Byte
Dim Station_id As Byte
Dim Name_pos As Byte
Dim Title_pos As Byte
Dim Vol As Byte
Dim Address As Byte
Dim Command As Byte
Dim Rc5_flag As Bit
Dim Str_len As Byte
Dim Search_init As Byte
Dim Pointer As Byte
Dim State As Byte
Dim Uart_ok As Bit
Dim Rolling As Bit
Dim Tik As Byte
Dim Mute As Bit
Dim Relay As Bit
Dim Light As Bit
Dim Buzzer_radio As Bit
Dim Alarm_on As Bit
Dim Seconds As Byte
Dim Minutes As Byte
Dim Godz_temp As Byte
Dim Hours As Byte
Dim Year_date As Byte
Dim Weekday_month As Byte
Dim Weekday As Byte
Dim Day_name As String * 9
Dim Month_name As String * 3
Dim Day As Byte
Dim Month As Byte
Dim Year As Byte
Dim Temp As Byte

Dim Volup1 As Byte
Dim Alt_volup1 As Byte
Dim Voldn1 As Byte
Dim Alt_voldn1 As Byte
Dim Next1 As Byte
Dim Prev1 As Byte
Dim Mute1 As Byte
Dim Relay1 As Byte
Dim Key_1 As Byte
Dim Key_2 As Byte
Dim Key_3 As Byte
Dim Key_4 As Byte
Dim Key_5 As Byte
Dim Key_6 As Byte
Dim Key_7 As Byte
Dim Key_8 As Byte
Dim Key_9 As Byte
Dim Key_0 As Byte
Dim Expected_address As Byte
Dim Backlight As Byte
Dim Menu_position As Byte
'----- Konfig portu B -----
Config Portb = Output
Portb = 255
'Portb0                                                     'LCD RESET
'Portb1                                                     'LCD ENABLE
'Portb2                                                     'LCD Data4
'Portb3                                                     'LCD Data5
'Portb4                                                     'LCD Data6
'Portb5                                                     'LCD Data7
'Portb6                                                     'Key: PREV
'Portb7                                                     'Key: NEXT

'----- Konfig portu C -----
Config Portc.0 = Output                                     '!!! Free !!!
Config Portc.1 = Output                                     'Relay driver
Config Portc.2 = Output                                     'Backlight driver
Config Portc.3 = Output                                     '!!! Free !!!
Config Portc.4 = Output                                     'I2C SDA
Config Portc.5 = Output                                     'I2C SCL
'Config Portc.6 = Input (NC)                                'NC
'Config Portc.7 = Input (NC)                                'NC
Portc = 255
'Pinc.4 = 0
'Pinc.5 = 0

'----- Konfig portu D -----
Config Portd.0 = Output                                     'RX pin for RS232C
Config Portd.1 = Output                                     'TX pin for RS232C
Config Portd.2 = Input                                      'IR receiver
Config Portd.3 = Output                                     '!!! Free !!!
Config Portd.4 = Output                                     'Red LED
Config Portd.5 = Output                                     'Key: VOL_UP
Config Portd.6 = Output                                     'Key: VOL_DN
Config Portd.7 = Output                                     'Key: ON / OFF
Portd = 255

'************************    INICJOWANIE UKLADU    ****************************
Portc.1 = 0                                                 'switch device off at startup
Portd.4 = 0                                                 'turn LED on (just to let me know if program started once ATmega8 is programmed)
Loop_counter = 25
Name_len = 0
Cls : Lcd "COMM INIT..."
Locate 2 , 1 : Lcd "v2.9  2010.12.19"
Wait 2
Cls
State = 2                                                   'potem zamienic na 0
Relay = 0
I = 0

Next1 = 32                                                  'this is definition of RC5 codes for keys / functions
Prev1 = 33                                                  'They can be changed here - no need to dig deeper into the code ;)
Voldn1 = 17 : Alt_volup1 = 56                               'alternates are for my second remote controller
Volup1 = 16 : Alt_voldn1 = 63
Mute1 = 13
Relay1 = 12
Key_1 = 1
Key_2 = 2
Key_3 = 3
Key_4 = 4
Key_5 = 5
Key_6 = 6
Key_7 = 7
Key_8 = 8
Key_9 = 9
Key_0 = 0

Portd.4 = 1                                                 'turn LED off - it meens - program is initiated well and running

'**************************    Main loop      ******************************
Main_loop:

Do

If State = 0 Then Gosub Boot
If State = 1 Then Gosub Work
If State = 2 Then Gosub Clock
Portd.4 = 1
Getrc5(address , Command)

If Command < 255 And Address < 255 Then
   Portd.4 = 0
   Command = Command And 127
   If Command = Next1 Then
      If State = 1 Then Gosub Mpc_next
      Backlight = 10
   End If

   If Command = Prev1 Then
      If State = 1 Then Gosub Mpc_prev
      Backlight = 10
   End If

   If Command = Voldn1 Or Command = Alt_voldn1 Then
      If State = 1 Then Gosub Vol_dn
      Backlight = 10
   End If

   If Command = Volup1 Or Command = Alt_volup1 Then
      If State = 1 Then Gosub Vol_up
      Backlight = 10
   End If

   If Command = Mute1 Then
      If State = 0 Then State = 1
      If State = 1 Then Gosub Vol_mute
      Backlight = 10
   End If

   If Command = Relay1 Then Gosub Toggle_state

   If Command < 10 Then
      If Command = Key_0 Then
         Station_id = 10
         Gosub Set_station
      End If

      If Command = Key_1 Then
         Station_id = 1
         Gosub Set_station
      End If

      If Command = Key_2 Then
         Station_id = 2
         Gosub Set_station
      End If

      If Command = Key_3 Then
         Station_id = 3
         Gosub Set_station
      End If

      If Command = Key_4 Then
         Station_id = 4
         Gosub Set_station
      End If

      If Command = Key_5 Then
         Station_id = 5
         Gosub Set_station
      End If

      If Command = Key_6 Then
         Station_id = 6
         Gosub Set_station
      End If

      If Command = Key_7 Then
         Station_id = 7
         Gosub Set_station
      End If

      If Command = Key_8 Then
         Station_id = 8
         Gosub Set_station
      End If

      If Command = Key_9 Then
         Station_id = 9
         Gosub Set_station
      End If

      Message = "Play station: " + Str(station_id)
      Gosub Display_info
      Gosub Command_out
   End If

End If
                                                            'Reading keyboard
If Pinb.7 = 0 Then                                          'Pinb.7 = NEXT station
   If State = 1 Then
      Gosub Blink_led
      Gosub Mpc_next
   End If
End If

If Pinb.6 = 0 Then                                          'Pinb.6 = PREV station
   If State = 1 Then
      Gosub Blink_led
      Gosub Mpc_prev
   End If
End If

If Pind.6 = 0 Then                                          'Pind.6 = VOL_UP
   If State = 1 Then
      Gosub Blink_led
      Gosub Vol_dn
   End If
End If

If Pind.5 = 0 Then                                          'Pind.5 = VOL_DN
   If State = 1 Then
      Gosub Blink_led
      Gosub Vol_up
   End If
End If

If Pind.7 = 0 Then                                          'Pind.7 = Manual ON/OFF
   Gosub Blink_led
   Bitwait Pind.7 , Set
   Gosub Toggle_state
End If

If Pinb.7 = 0 And Pinb.6 = 0 Then                           'Both Pinb.7 & Pinb.6 = go to time management section
   Gosub Blink_led
   Bitwait Pinb.7 , Set
   Bitwait Pinb.6 , Set
   Goto Clock_setup
End If

If State < 2 Then                                           'if device is active or is just starting
   Backlight = 0                                            'then always turn LSC backlight on
Else
   If Backlight > 0 Then                                    'if sevice is turned off - set backlight depending on value
      Portc.2 = 0                                           'of variable "backlight" - the goal is to have backlight turned on
   Else                                                     'for some time after any recognizable remote command is received
      Portc.2 = 1                                           'exception : Command "Relay1" or "Relay2" - these commands will
   End If                                                   'turn device on into state "starting", State=1 and backlight will be
End If                                                      'turned premanently on

If State = 2 Then Relay = 0
If State = 0 Or State = 1 Then Relay = 1
Portc.1 = Relay                                             'driving relay depending on value of variable "Relay"

Loop
End

'_______________________________________________________________________________
Receive_from_uart:                                          'receive data from UART

C = ""
Do
B = Ischarwaiting()
If B > 0 Then
   A = Inkey()                                              'string's C max lenght is 180 characters
   If Len(c) < 179 Then C = C + Chr(a)                      'collecting characters until lenght C<179
   If Len(c) = 179 Then C = C + Chr(13)                     'if lenght C=179 then add CR character as 180th (necessary for parser to work OK)
End If                                                      'signs after 180th are ignored
Loop Until B = 0                                            'repeat until UART buffer not empty
Return

'_______________________________________________________________________________
Flush_buffer:                                               'flush UART buffer

Do
   A = Inkey()                                              'get character from UART buffer
   B = Ischarwaiting()                                      'chack if buffer is empty
Loop Until B = 0                                            'repeat until buffer is not empty
Return

'_______________________________________________________________________________
Decode_title:

Play = ""
Title = ""
Syg1 = Instr(c , "Name: ")
Syg2 = Instr(c , "Title: ")

'parser: Name
Name_pos = Syg1 + 6
Search_init = Name_pos
Gosub Find_string_end
Name_len = Str_len
If Name_len > 48 Then Name_len = 48
Play = Mid(c , Name_pos , Name_len)

'parser: Title
Title_pos = Syg2 + 7
Search_init = Title_pos
Gosub Find_string_end
Title_len = Str_len
If Title_len > 48 Then Title_len = 48
Title = Mid(c , Title_pos , Title_len)

If Name_pos = 6 Then Play = "Name not found!"
If Title_pos = 7 Then Title = "Title not found!"
If Rolling = 1 Then
   Cls : Lcd Play
   Locate 2 , 1 : Lcd Title
End If
Return

'_______________________________________________________________________________
Find_string_end:

Str_len = 0
Do
   Incr Str_len
   Pointer = Search_init + Str_len
   Temp_str = Mid(c , Pointer , 1)
Loop Until Temp_str = Chr(13) Or Temp_str = ""
Return

'_______________________________________________________________________________
Get_mpc_status:

Print "echo " ; Chr(34) ; "currentsong" ; Chr(34) ; " | nc localhost 6600 | grep -e " ; Chr(34) ; "^Title: " ; Chr(34) ; " -e " ; Chr(34) ; "^Name: " ; Chr(34) ; Chr(13)       '; " > /dev/tts/0" ; Chr(13)
Return

'_______________________________________________________________________________
Mpc_next:

Incr Station_id
If Station_id > 20 Then Station_id = 1                      'virtual limit of supported stations: 20
Gosub Set_station
Message = "Play station: " + Str(station_id)                'prepare message to be displayed on LCD
Gosub Display_info                                          'call subproc to display information on LCD
Gosub Command_out                                           'call subproc to finish communication with router in proper way
Return

'_______________________________________________________________________________
Mpc_prev:

Decr Station_id
If Station_id = 0 Then Station_id = 20                      'comments not necessary - see: subproc above
Gosub Set_station
Message = "Play station: " + Str(station_id)                'will be optimized
Gosub Display_info
Gosub Command_out
Return

'_______________________________________________________________________________

Vol_mute:

Toggle Mute                                                 'toggle a MUTE bit flag
If Mute = 1 Then                                            'in case MUTE toggled to 1
   Print "mpc volume 0" ; Chr(13)                           'send command to router (vol 0)
   Message = "VOLUME: MUTE"                                 'prepare message to be displayed on LCD
End If

If Mute = 0 Then                                            'in case MUTE is toggled to 0 (unmute)
   Gosub Set_volume
   Message = "VOLUME: " + Str(vol) + "%"                    'prepare message to be displayed on LCD
End If
Gosub Display_info
Gosub Command_out
Return

'_______________________________________________________________________________
Vol_up:

If Vol < 96 Then
   If Vol > 59 Then Vol = Vol + 5                           'below Vol=60% step is 10%
   If Vol < 60 Then Vol = Vol + 10                          'for Vol=60% and more - step is 5%
   Message = "Volume UP: " + Str(vol) + "%"                 'prepare message to be displayed on LCD
Else
   Vol = 100                                                'in case Vol=100% and user requested Vol+
   Message = "Volume MAX"                                   'prepare message to be displayed on LCD (and do nothing with Vol!)
End If
Gosub Set_volume
Gosub Display_info
Gosub Command_out
Return

'_______________________________________________________________________________
Vol_dn:

If Vol > 9 Then                                             'comments not necessary - see: subproc above
    If Vol < 61 Then Vol = Vol - 10
    If Vol > 60 Then Vol = Vol - 5
    Message = "Volume DN: " + Str(vol) + "%"
Else
    Vol = 0
    Message = "Volume MIN"
End If
Gosub Set_volume
Gosub Display_info
Gosub Command_out
Return

'_______________________________________________________________________________
Set_volume:

Print "mpc volume " ; Str(vol) ; Chr(13)
Return

'_______________________________________________________________________________
Set_station:

Print "mpc play " ; Str(station_id) ; Chr(13)
Return

'_______________________________________________________________________________
Rotate_display:

If Rolling = 1 Then Shiftlcd Left                           'depending on flag Rolling - shift lcd left
Return

'_______________________________________________________________________________
Command_out:
Portd.4 = 1
Loop_counter = 25                                           'set loop counter for obtaining title & name when in next loop
Gosub Save_radio_details                                    'save VOL, STATION_ID + flags to DS8583
Waitms 250                                                  'wait (protection against next command receiption)
Gosub Flush_buffer                                          'flush UART buffer
Return

'_______________________________________________________________________________
Toggle_state:

If State = 2 Then
   Cls : Lcd "Hello..."                                     'Display "Hello..."
   State = 0
Else
   Print "mpc stop" ; Chr(13)                               'send "mpc stop" command before power off
   Cls : Lcd "Bye..."                                       'Display "Bye..."
   State = 2                                                'switch state to closk
End If
Wait 2
Return

'_______________________________________________________________________________
Test_uart:

   B = Ischarwaiting()                                      'check if there is some data waiting in UART buffer
   If B = 1 Then                                            'if YES
      Uart_ok = 1                                           'set UART_OK flag to 1
   Else                                                     'if NO
       Uart_ok = 0                                          'set this flag to 0
   End If
Return

'_______________________________________________________________________________
Display_info:

Cls : Lcd "Command:"                                        'output from VOL UP/DN and STATION UP/DN - will display
Locate 2 , 1 : Lcd Message                                  'message prepared by these subprocs
Return

'_______________________________________________________________________________
Name_the_day:

If Weekday = 0 Then Day_name = "Sunday"                     'the simpliest possible value - value converter
If Weekday = 1 Then Day_name = "Monday"                     'no need to comment it, I think...
If Weekday = 2 Then Day_name = "Tuesday"
If Weekday = 3 Then Day_name = "Wednesday"
If Weekday = 4 Then Day_name = "Thursday"
If Weekday = 5 Then Day_name = "Friday"
If Weekday = 6 Then Day_name = "Saturday"
Return

'_______________________________________________________________________________
Name_the_month:

If Month = 1 Then Month_name = "Jan"                        'almost the same as above - but is converting months
If Month = 2 Then Month_name = "Feb"
If Month = 3 Then Month_name = "Mar"
If Month = 4 Then Month_name = "Apr"
If Month = 5 Then Month_name = "May"
If Month = 6 Then Month_name = "Jun"
If Month = 7 Then Month_name = "Jul"
If Month = 8 Then Month_name = "Aug"
If Month = 9 Then Month_name = "Sep"
If Month = 10 Then Month_name = "Oct"
If Month = 11 Then Month_name = "Nov"
If Month = 12 Then Month_name = "Dec"
Return

'_______________________________________________________________________________
Read_clock:                                                 'Reading data from PCF8583

   I2cstart                                                 '
   I2cwbyte 160                                             'Write PCF8583's addres to write
   I2cwbyte 2                                               'info: reading must start from byte 02 (00-status registes, 01 - 0.01/secs)
   I2cstart                                                 '
   I2cwbyte 161                                             'Write PCF8583's addres to read
   I2crbyte Seconds , Ack                                   'read seconds register (byte 02)
   I2crbyte Minutes , Ack                                   'read minutes register (byte 03)
   I2crbyte Godz_temp , Ack                                 'read hours register (byte 04)
   I2crbyte Year_date , Ack                                 'read year/date register (byte 05)
   I2crbyte Weekday_month , Nack                            'read weekday/month register (byte 06)
   I2cstop                                                  'end of I2C communication
Seconds = Makedec(seconds)                                  'convert seconds from BCD to DEC format
Minutes = Makedec(minutes)                                  'do the same for minutes

'Calcouation for hours:
   Hours = 0                                                'set hours to 0
   If Godz_temp.0 = 1 Then Hours = Hours + 1                'and calculate real value bit by bit
   If Godz_temp.1 = 1 Then Hours = Hours + 2                'as it is not as easy as BCD > DEC conversion for seconds / minutes
   If Godz_temp.2 = 1 Then Hours = Hours + 4                '
   If Godz_temp.3 = 1 Then Hours = Hours + 8                '
   If Godz_temp.4 = 1 Then Hours = Hours + 10               '
   If Godz_temp.5 = 1 Then Hours = Hours + 20               '

'Calculation for days:
   Day = 0                                                  'set days to 0
   If Year_date.0 = 1 Then Day = Day + 1                    'and calculate its real value bit by bit
   If Year_date.1 = 1 Then Day = Day + 2                    '
   If Year_date.2 = 1 Then Day = Day + 4                    '
   If Year_date.3 = 1 Then Day = Day + 8                    '
   If Year_date.4 = 1 Then Day = Day + 10                   '
   If Year_date.5 = 1 Then Day = Day + 20                   '

'Obliczanie miesiecy:
   Weekday = 0
   Month = 0                                                'set months to 0
   If Weekday_month.0 = 1 Then Month = Month + 1            'and calculate its real value but by bit
   If Weekday_month.1 = 1 Then Month = Month + 2            '
   If Weekday_month.2 = 1 Then Month = Month + 4            '
   If Weekday_month.3 = 1 Then Month = Month + 8            '
   If Weekday_month.4 = 1 Then Month = Month + 10           '
   If Weekday_month.5 = 1 Then Weekday = Weekday + 1        'do the same for week days
   If Weekday_month.6 = 1 Then Weekday = Weekday + 2        '
   If Weekday_month.7 = 1 Then Weekday = Weekday + 4        '

   I2cstart                                                 '
   I2cwbyte 160                                             'Write PCF8583's addres to write
   I2cwbyte 200                                             'Year is stored in byte #200
   I2cstart                                                 '
   I2cwbyte 161                                             'Write PCF8583's addres to read
   I2crbyte Year , Nack
   I2cstop

 Return

'_______________________________________________________________________________
Write_clock:
Portd.4 = 0                                                 'turn LED on
   I2cstart                                                 'Init I2C bus
   I2cwbyte 160                                             'PCF8583 address to write to
   I2cwbyte 2                                               'start writting from byte #2
   I2cwbyte Seconds                                         'write Seconds
   I2cwbyte Minutes                                         'write Minutes
   I2cwbyte Godz_temp                                       'write Hours
   I2cwbyte Year_date                                       'write Day
   I2cwbyte Weekday_month                                   'write Month
   I2cstop                                                  'stop I2C bus
Waitms 10
   I2cstart                                                 'Init I2C bus
   I2cwbyte 160                                             'PCF8583 address to write to
   I2cwbyte 200                                             'zstart writting from byte #200
   I2cwbyte Year                                            'write Year
   I2cstop                                                  'stop I2C bus
   Portd.4 = 1                                              'turn LED off
Return

'_______________________________________________________________________________
Clock:

Incr Loop_counter
If Loop_counter = 150 Then
   Loop_counter = 0
   Gosub Read_clock
   Gosub Name_the_day
   Gosub Name_the_month

   Cls
'Upper line
'Hours
   If Hours < 10 Then Lcd " "
   Lcd Hours ; ":"
'Minutes
   If Minutes < 10 Then Lcd "0"
   Lcd Minutes ; ":"
'Seconds
   If Seconds < 10 Then Lcd "0"
   Lcd Seconds
'data
   Locate 1 , 11
   If Day < 10 Then Lcd " "
   Lcd Day ; " " ; Month_name

'Lower line
   Locate 2 , 1 : Lcd Day_name
'Year
   Locate 2 , 13 : Lcd "20" : Lcd Year
   Waitms 150
End If

Return

'_______________________________________________________________________________
Save_radio_details:
Temp.0 = Mute                                               'compose my status register

 I2cstart                                                   '
 I2cwbyte 160                                               'PCF8583 address to write
 I2cwbyte 32                                                'start from byte #32
 I2cwbyte Vol                                               'write volume level
 I2cwbyte Station_id                                        'write current station number
 I2cwbyte Temp                                              'write my status register
 I2cstop                                                    '
Return

'_______________________________________________________________________________
'Save_remote_codes:
' I2cstart
' I2cwbyte 160                                               'PCF8583 address to write
' I2cwbyte 48                                                'start writting from byte #48
' I2cwbyte Volup1                                            'write code for VolUp1
' I2cwbyte Voldn1                                            'write code for Voldn1
' I2cwbyte Next1                                             'write code for Next1
' I2cwbyte Prev1                                             'write code for Prev1
' I2cwbyte Mute1                                             'write code for Mute1
' I2cwbyte Relay1                                            'write code for Relay1
' I2cwbyte Expected_address                                  'write code for Expected_address (end at byte #64)
' I2cwbyte Key_1
' I2cwbyte Key_2
' I2cwbyte Key_3
' I2cwbyte Key_4
' I2cwbyte Key_5
' I2cwbyte Key_6
' I2cwbyte Key_7
' I2cwbyte Key_8
' I2cwbyte Key_9
' I2cwbyte Key_0
' I2cstop
'Return

'_______________________________________________________________________________
'Restore_remote_codes:
'
' I2cstart                                                   '
' I2cwbyte 160                                               'PCF8583's addres to write
' I2cwbyte 48                                                'strt reading from byte #48
' I2cstart                                                   'I2C bus restart
' I2cwbyte 161                                               'PCF8583's addres to read
' I2crbyte Volup1 , Ack                                      'read code for VolUp1
' I2crbyte Voldn1 , Ack                                      'read code for Voldn1
' I2crbyte Next1 , Ack                                       'read code for Next1
' I2crbyte Prev1 , Ack                                       'read code for Prev1
' I2crbyte Mute1 , Ack                                       'read code for Mute1
' I2crbyte Relay1 , Ack                                      'read code for Relay1
' I2crbyte Expected_address , Ack                            'read code for Expected_address (end at byte #61)
' I2crbyte Key_1 , Ack
' I2crbyte Key_2 , Ack
' I2crbyte Key_3 , Ack
' I2crbyte Key_4 , Ack
' I2crbyte Key_5 , Ack
' I2crbyte Key_6 , Ack
' I2crbyte Key_7 , Ack
' I2crbyte Key_8 , Ack
' I2crbyte Key_9 , Ack
' I2crbyte Key_0 , Ack
' I2cstop
'Return

'_______________________________________________________________________________
Recover_radio_details:

 I2cstart                                                   'init I2C bus
 I2cwbyte 160                                               'PCF8583 address to write to
 I2cwbyte 32                                                'start from byte #32
 I2cstart                                                   'I2C init
 I2cwbyte 161                                               'PCF8583 address to read from
 I2crbyte Vol , Ack                                         'read volume level
 I2crbyte Station_id , Ack                                  'read current station number
 I2crbyte Temp , Nack                                       'read my status register
 I2cstop                                                    'stop I2C bus

Mute = Temp.0                                               'recover statuses from register
Return

'_______________________________________________________________________________
Boot:

   Incr Loop_counter

   If Loop_counter = 10 Then                                '60
      Loop_counter = 0
      Gosub Receive_from_uart
      If Len(c) > 0 Then
         Portd.4 = 0
      Else
         Portd.4 = 1
      End If

      Syg1 = Instr(c , "AVR Start!")
      If Syg1 > 0 Then
         State = 1
         Gosub Recover_radio_details                        'last known settings recovery (station + volume level)
         Print Chr(13)                                      'OpenWRT init - let OpenWRT give a prompt
         Waitms 200
         Gosub Set_volume                                   'set last known level of volume
         Waitms 200
         Gosub Set_station                                  'set last known station
         Waitms 200
         Gosub Flush_buffer                                 'flushing UART buffer
         Loop_counter = 25                                  'value is necessary when entering State 1
      Else
         Locate 1 , 1 : Lcd "Boot to OpenWRT "
         Locate 2 , 1 : Lcd "Please wait..."
      End If
   End If
Return
'_______________________________________________________________________________
Work:

   If Loop_counter = 25 Then Rolling = 1
   If Loop_counter > 24 Then
      Loop_counter = 0
      Uart_ok = 0
      Gosub Flush_buffer
      Waitms 50
      Gosub Get_mpc_status
      Waitms 200
      Waitms 100
      Gosub Test_uart
      If Uart_ok = 1 Then
         Gosub Receive_from_uart
         Gosub Decode_title
         Gosub Flush_buffer
      Else
          Rolling = 0
          Cls : Lcd "OpenWRT is not"
          Locate 2 , 1 : Lcd "responding..."
      End If
   Else
      Incr Tik
      If Tik = 90 Then                                      'higher value - slower scroll on LCD display
         Incr Loop_counter
         Gosub Rotate_display
         Tik = 0
      End If
   End If
 Return

'_______________________________________________________________________________
Clock_setup:

Cls
Menu_position = 1
Gosub Read_clock
If Year < 10 Then Year = 10                                 'for protection during first start
Do
If Pinb.7 = 0 Or Pinb.6 = 0 Then
   Bitwait Pinb.7 , Set                                     'changing menu position
   Bitwait Pinb.6 , Set
   Incr Menu_position
   If Menu_position > 6 Then Menu_position = 1
   Cls
End If
Locate 1 , 1 : Lcd "Time setup"
Locate 2 , 1
If Menu_position = 1 Then Lcd "Minutes: " ; Minutes
If Menu_position = 2 Then Lcd "Hours: " ; Hours
If Menu_position = 3 Then Lcd "Year: " ; Year
If Menu_position = 4 Then Lcd "Month: " ; Month
If Menu_position = 5 Then Lcd "Day: " ; Day
If Menu_position = 6 Then
   Gosub Name_the_day
   Lcd "Weekday: " ; Day_name
End If

If Pind.6 = 0 Then                                          'adding values
  Locate 2 , 1
  If Menu_position = 1 Then                                 'Minutes
     Incr Minutes
     If Minutes > 59 Then Minutes = 0
  End If

  If Menu_position = 2 Then                                 'Hours
     Incr Hours
     If Hours > 23 Then Hours = 0
  End If

  If Menu_position = 3 Then                                 'Year
     Incr Year
     If Year > 30 Then Year = 10
  End If

  If Menu_position = 4 Then                                 'Month
     Incr Month
     If Month > 12 Then Month = 1
  End If

  If Menu_position = 5 Then                                 'Day + filter dependant on value of month
     Incr Day
     If Month = 1 Or Month = 3 Or Month = 5 Or Month = 7 Or Month = 8 Or Month = 10 Or Month = 12 Then
        If Day > 31 Then Day = 1
     End If
     If Month = 4 Or Month = 6 Or Month = 9 Or Month = 11 Then
        If Day > 30 Then Day = 1
     End If
     If Month = 2 Then
        If Year.0 = 0 And Year.1 = 0 Then
           If Day > 28 Then Day = 1
        Else
           If Day > 29 Then Day = 1
        End If
     End If
  End If

  If Menu_position = 6 Then
     Incr Weekday
     If Weekday > 6 Then Weekday = 0
  End If
  Bitwait Pind.6 , Set
Cls
End If

If Pind.7 = 0 Then
   Bitwait Pind.7 , Set
'Below part is a conversion of time and date to values acceptable for PCF8583
   Seconds = 0
   Minutes = Makebcd(minutes)
   Godz_temp = Makebcd(hours)
   Godz_temp.6 = 0
   Godz_temp.7 = 0

   Year_date = Makebcd(day)
   Year_date.6 = Year.0
   Year_date.7 = Year.1

   Weekday_month = Makebcd(month)
   Weekday_month.5 = Weekday.0
   Weekday_month.6 = Weekday.1
   Weekday_month.7 = Weekday.2
   Gosub Write_clock
   Goto Main_loop
End If
Loop

'_______________________________________________________________________________
Blink_led:
Portd.4 = 0
Waitms 20
Portd.4 = 1
Return

'_______________________________________________________________________________